<?php defined('SYSPATH') or die('No direct script access.');

class Model_Students extends Model
{
    public static function factory() {
        return new self;
    }

    public function getGroups($gradeNum, $facultyID) {
        $sql = "CALL `GetGroups`('$gradeNum', '$facultyID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function getGradeID($gradeNum, $degree) {
        $degree = Database::instance()->escape($degree);
        $sql = "SELECT `GetGradeID`('$gradeNum', $degree) AS `ID`; ";
        return DB::query(Database::SELECT, $sql)->execute()->get('ID');
    }

    /**
     * @deprecated
     * todo: move to model_student
     */
    public function getDegreeTitle($degree) {
        switch ($degree) {
            case 'bachelor':
                return 'Бакалавриат';
            case 'specialist':
                return 'Специалитет';
            case 'master':
                return 'Магистратура';
            default:
                return $degree;
        }
    }

    public function byStudyGroup($groupID) {
        $sql = "CALL `GetStudents`('$groupID'); ";
        $students = DB::query(Database::SELECT, $sql)->execute();
        return new DataArray_Result($this->collect($students));
    }

    public function byFaculty($facultyID, $gradeID, $groupID) {
        $sql = "CALL `GetStudentsByFaculty`('$facultyID', '$gradeID', $groupID); ";
        $students = DB::query(Database::SELECT, $sql)->execute();
        return new DataArray_Result($this->collect($students));
    }

    public function byGradeID($facultyID, $gradeID) {
        $sql = "CALL `GetStudentsByFaculty`('$facultyID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function searchStudents($GradeID, $GroupID, $FacultyID, $Name, $DisciplineID) {
        $Name = Database::instance()->escape($Name);
        $sql = "CALL `SearchStudents`('$GradeID', '$GroupID', '$FacultyID', $Name, '$DisciplineID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    protected function collect($students) {
        $studentsHandled = array();
        foreach($students as $row) {
            $row['Degree'] = $this->getDegreeTitle($row['Degree']);
            $studentsHandled[] = $row;
        }
        return $studentsHandled;
    }

    public function NotAttendingDiscipline($GradeID, $GroupID, $FacultyID, $Name, $DisciplineID) {
        $students = $this->searchStudents($GradeID, $GroupID, $FacultyID, $Name, $DisciplineID);
        return new DataArray_Result($this->collect($students));
    }
}